package com.twitter.flockdb.test

import com.twitter.gizzard.test.Database
import com.twitter.ostrich.W3CStats
import net.lag.configgy.Configgy
import net.lag.logging.Logger


object StaticEdges extends Database {
  Configgy.configure("config/test.conf")

  val poolConfig = Configgy.config.configMap("db.connection_pool")
  val log = Logger.get
  val config = Configgy.config
  val w3c = new W3CStats(log, config.getList("edges.w3c").toArray)
  val stats = FlockDB.statsCollector(w3c)

  lazy val flock = try {
    FlockDB(config, databaseFactory, databaseFactory, w3c, stats)
  } catch {
    case e =>
      e.printStackTrace()
      throw e
  }
}
